<?php
/*
    Copyright(c) 2010 Shift Tech Inc. All Rights Reserved.
     http://www.shift-tech.jp/
*/

require_once (LIB_PATH.'/common/unitCommon.php');
require_once (LIB_PATH.'/common/pageView.php');
require_once (LIB_PATH.'/common/imgmngrDB.php');
require_once (LIB_PATH.'/common/labelDB.php');
/*
--画像タイトルテキスト用 の詳細データ格納テーブル（公開情報）
CREATE TABLE extunit_extcatlist4 (
    pageu_code			integer,			--ユニット配列順序における登録番号
    catlist_sidx_code	integer,			--セクションIDXコード
    catlist_cat_code	text,					--カテゴリーコードの文字列「:」で区切って保存
    catlist_layout_pc		smallint,			--PC用テンプレートNo.
    catlist_layout_sp		smallint,			--スマホ用テンプレートNo.
    catlist_s_count		integer,				--表示開始件数
    catlist_limit		integer,				--表示情報件数設定
    catlist_pflg		smallint default 1,		--ページングの有無 0：なし　1：あり
    catlist_date_flg	smallint default 1,		--日付表示の有無 0：なし　1：あり
    catlist_date_format	text,				--日付書式
    catlist_rss			smallint default 1,		--RSS 0：なし　1：あり
    catlist_new_flg		smallint default 1,		--NEWアイコン表示 0：なし　1：あり
    catlist_comment_flg	smallint default 1,		--一覧コメント 0：なし　1：あり
    catlist_new_days	integer,			--NEWアイコン表示期間
    catlist_order		smallint default 1,		--表示順　1：公開日の昇順　2：公開日の降順
    catlist_sp_layout 		smallint not null default 0,		--スマホレイアウト（フリック）1：使う
    catlist_comming_text	text,				--カミングスーンテキスト
    catlist_comming_flg	smallint default 0,		--カミングスーンテキスト
    catlist_nodata_text	text,				--データ無し時の表示テキスト
    catlist_link_text		text,				--詳細へのリンクテキスト：初期値「詳細はこちら」
    catlist_nophoto_img	text,				--画像が無い時に表示する初期画像 初期値：no photo
    catlist_newicon_img	text,				--新着時に表示する画像
    catlist_effect 			text,				--エフェクト
    catlist_speed 			smallint default 1000,				--スピード
    catlist_easing 		text,				--イージング
    catlist_pager_flg 		smallint DEFAULT '0',		--ページャータイプ 0:ボタン、1:スクロール
    catlist_pager_text 		text,						--ページャー任意テキスト
    catlist_pager_img text,							-- ページャー画像
    catlist_pager_img_hover text,					-- ページャー画像hover
    catlist_body_charcnt smallint DEFAULT '0', 		-- 文字数
    catlist_image_height 		text, 				--【extCatList4】 画像の高さ
    catlist_object_height 		text, 				--【extCatList4】 オブジェクトの高さ
    catlist_margin			text, 				--【extCatList4】 間隔
    catlist_column 		smallint default 1, 		--【extCatList4】 横列数
    catlist_outside_flg 		smallint default 1, 		--【extCatList4】 外枠 表示/非表示
    catlist_outside_color 	text, 				--【extCatList4】 外枠 色
    catlist_outside_weight 	text, 				--【extCatList4】 外枠 太さ
    catlist_default_bgcolor 	text, 			--【extCatList4】 デフォルト背景
    catlist_hovered_bgcolor 	text, 			--【extCatList4】 デフォルト背景hover時
    catlist_color 			text, 				--【extCatList4】 文字（色）
    catlist_color_hover 	text, 				--【extCatList4】 文字（色）hover時
    catlist_hover_effect 	text, 				--【extCatList4】 hover時効果
    catlist_auto_centering 	smallint default 0, 		--【extCatList4】 自動中央揃え
    bg_color			smallint default 0,		--背景色　0：なし　1：あり
    bdr_type			smallint default 0,		--囲み線　0：なし　1：実線　2：点線
    btm_padding			smallint default 2,		--下部余白　0:なし　1：狭　2：標準　3：広
    bg_color_sp			smallint default 0,		--背景色　0：なし　1：あり
    bdr_type_sp			smallint default 0,		--囲み線　0：なし　1：実線　2：点線
    btm_padding_sp			smallint default 2,		--下部余白　0:なし　1：狭　2：標準　3：広
    primary key (pageu_code)
);
CREATE TABLE extunit_extcatlist4_tmp (
    pageu_code			integer,			--ユニット配列順序における登録番号
    catlist_sidx_code	integer,			--セクションIDXコード
    catlist_cat_code	text,					--カテゴリーコードの文字列「:」で区切って保存
    catlist_label_code	text,
    catlist_layout_pc		smallint,			--PC用テンプレートNo.
    catlist_layout_sp		smallint,			--スマホ用テンプレートNo.
    catlist_s_count		integer,				--表示開始件数
    catlist_limit		integer,				--表示情報件数設定
    catlist_pflg		smallint default 1,		--ページングの有無 0：なし　1：あり
    catlist_date_flg	smallint default 1,		--日付表示の有無 0：なし　1：あり
    catlist_date_format	text,				--日付書式
    catlist_rss			smallint default 1,		--RSS 0：なし　1：あり
    catlist_new_flg		smallint default 1,		--NEWアイコン表示 0：なし　1：あり
    catlist_comment_flg	smallint default 1,		--一覧コメント 0：なし　1：あり
    catlist_new_days	integer,			--NEWアイコン表示期間
    catlist_order		smallint default 1,		--表示順　1：公開日の昇順　2：公開日の降順
    catlist_sp_layout 		smallint not null default 0,		--スマホレイアウト（フリック）1：使う
    catlist_comming_text	text,				--カミングスーンテキスト
    catlist_comming_flg	smallint default 0,		--カミングスーンテキスト
    catlist_nodata_text	text,				--データ無し時の表示テキスト
    catlist_link_text		text,				--詳細へのリンクテキスト：初期値「詳細はこちら」
    catlist_nophoto_img	text,				--画像が無い時に表示する初期画像 初期値：no photo
    catlist_newicon_img	text,				--新着時に表示する画像
    catlist_effect 			text,				--エフェクト
    catlist_speed 			smallint default 1000,				--スピード
    catlist_easing 		text,				--イージング
    catlist_pager_flg 		smallint DEFAULT '0',		--ページャータイプ 0:ボタン、1:スクロール
    catlist_pager_text 		text,						--ページャー任意テキスト
    catlist_pager_img text,							-- ページャー画像
    catlist_pager_img_hover text,					-- ページャー画像hover
    catlist_body_charcnt smallint DEFAULT '0', 		-- 文字数
    catlist_image_height 		text, 				--【extCatList4】 画像の高さ
    catlist_object_height 		text, 				--【extCatList4】 オブジェクトの高さ
    catlist_column 		smallint default 1, 		--【extCatList4】 横列数
    catlist_margin			text, 				--【extCatList4】 間隔
    catlist_outside_flg 		smallint default 1, 		--【extCatList4】 外枠 表示/非表示
    catlist_outside_color 	text, 				--【extCatList4】 外枠 色
    catlist_outside_weight 	text, 				--【extCatList4】 外枠 太さ
    catlist_default_bgcolor 	text, 			--【extCatList4】 デフォルト背景
    catlist_hovered_bgcolor 	text, 			--【extCatList4】 デフォルト背景hover時
    catlist_color 			text, 				--【extCatList4】 文字（色）
    catlist_color_hover 	text, 				--【extCatList4】 文字（色）hover時
    catlist_hover_effect 	text, 				--【extCatList4】 hover時効果
    catlist_auto_centering 	smallint default 0, 		--【extCatList4】 自動中央揃え
    bg_color			smallint default 0,		--背景色　0：なし　1：あり
    bdr_type			smallint default 0,		--囲み線　0：なし　1：実線　2：点線
    btm_padding			smallint default 2,		--下部余白　0:なし　1：狭　2：標準　3：広
    bg_color_sp			smallint default 0,		--背景色　0：なし　1：あり
    bdr_type_sp			smallint default 0,		--囲み線　0：なし　1：実線　2：点線
    btm_padding_sp			smallint default 2,		--下部余白　0:なし　1：狭　2：標準　3：広
    primary key (pageu_code)
);
 */

class extCatList4 extends unitCommon
{
    //------ ユニット毎に必ず設定しなくてはならない変数 -------//
    var $_table = "extunit_extcatlist4"; //公開用テーブル名
    var $_tmptable = "extunit_extcatlist4_tmp"; //下書き用テーブル名 //必ず公開用テーブル名のうしろに_tmpをつけてください
    var $columns = array(
                    array("column"=>"pageu_code","conv"=>"n","tags"=>false),		//ユニット登録コード
                    array("column"=>"catlist_sidx_code","conv"=>"","tags"=>false),	//セクションIDXコード
                    array("column"=>"catlist_cat_code","conv"=>"","tags"=>false),	//カテゴリーコードの文字列「:」で区切って保存
                    array("column"=>"catlist_layout_pc","conv"=>"n","tags"=>false),		//PC用テンプレートNo.
                    array("column"=>"catlist_layout_sp","conv"=>"n","tags"=>false),		//スマホ用テンプレートNo.
                    array("column"=>"catlist_label_code","conv"=>"","tags"=>false),	//ラベルコードの文字列「:」で区切って保存
                    array("column"=>"catlist_s_count","conv"=>"","tags"=>false),	//表示開始件数
                    array("column"=>"catlist_limit","conv"=>"","tags"=>false),		//表示情報件数設定
                    array("column"=>"catlist_pflg","conv"=>"","tags"=>false),		//ページングの有無 0：なし　1：あり
                    array("column"=>"catlist_date_flg","conv"=>"","tags"=>false),	//公開日表示 0：なし　1：あり
                    array("column"=>"catlist_date_format","conv"=>"","tags"=>false),	//公開日の日付書式
                    array("column"=>"catlist_rss","conv"=>"","tags"=>false),		//RSS 0：なし　1：あり
                    array("column"=>"catlist_new_flg","conv"=>"","tags"=>false),	//NEWアイコン表示 0：なし　1：あり
                    array("column"=>"catlist_comment_flg","conv"=>"","tags"=>false),//一覧コメント 0：なし　1：あり
                    array("column"=>"catlist_new_days","conv"=>"","tags"=>false),	//NEWアイコン表示期間
                    array("column"=>"catlist_order","conv"=>"","tags"=>false),		//表示順　1：公開日の昇順　2：公開日の降順
                    array("column"=>"catlist_sp_layout","conv"=>"n","tags"=>false),		//スマホレイアウト（フリック）1：使う
                    array("column"=>"catlist_comming_text","conv"=>"KV","tags"=>false),		//カミングスーンテキスト
                    array("column"=>"catlist_comming_flg","conv"=>"","tags"=>false),		//カミングスーンテキスト表示の有無 0：なし　1：あり
                    array("column"=>"catlist_nodata_text","conv"=>"KV","tags"=>true),			//データ無し時の表示テキスト
                    array("column"=>"catlist_link_text","conv"=>"KV","tags"=>false),			//詳細へのリンクテキスト：初期値「詳細はこちら」
                    array("column"=>"catlist_nophoto_img","conv"=>"a","tags"=>false),			//画像が無い時に表示する初期画像 初期値：no photo
                    array("column"=>"catlist_newicon_img","conv"=>"a","tags"=>false),			//新着時に表示する画像
                    array("column"=>"catlist_effect","conv"=>"KV","tags"=>false),			//エフェクト
                    array("column"=>"catlist_speed","conv"=>"","tags"=>false),				//スピード
                    array("column"=>"catlist_easing","conv"=>"KV","tags"=>false),			//イージング
                    array("column"=>"catlist_pager_flg","conv"=>"","tags"=>false),				//ページングタイプ 0：ボタン　1：スクロール
                    array("column"=>"catlist_pager_text","conv"=>"KV","tags"=>false),			//ページング任意テキスト
                    array("column"=>"catlist_pager_img","conv"=>"KV","tags"=>false),			//ページング画像
                    array("column"=>"catlist_pager_img_hover","conv"=>"KV","tags"=>false),		//ページング画像hover
                    array("column"=>"catlist_body_charcnt","conv"=>"","tags"=>false),			//文字数
                    // 【extCatList4】<!--
                    array("column"=>"catlist_image_height","conv"=>"KV","tags"=>false),		//【extCatList4】 画像の高さ
                    array("column"=>"catlist_object_height","conv"=>"KV","tags"=>false),		//【extCatList4】 オブジェクトの高さ
                    array("column"=>"catlist_margin","conv"=>"KV","tags"=>false),				//【extCatList4】 間隔
                    array("column"=>"catlist_column","conv"=>"","tags"=>false),				//【extCatList4】 横列数
                    array("column"=>"catlist_outside_flg","conv"=>"","tags"=>false),				//【extCatList4】 外枠 表示/非表示
                    array("column"=>"catlist_outside_color","conv"=>"KV","tags"=>false),		//【extCatList4】 外枠 色
                    array("column"=>"catlist_outside_weight","conv"=>"KV","tags"=>false),		//【extCatList4】 外枠 太さ
                    array("column"=>"catlist_default_bgcolor","conv"=>"KV","tags"=>false),		//【extCatList4】 デフォルト背景
                    array("column"=>"catlist_hovered_bgcolor","conv"=>"KV","tags"=>false),		//【extCatList4】 デフォルト背景 hover時
                    array("column"=>"catlist_color","conv"=>"KV","tags"=>false),				//【extCatList4】 文字（色）
                    array("column"=>"catlist_color_hover","conv"=>"KV","tags"=>false),				//【extCatList4】 文字（色）hover時
                    array("column"=>"catlist_hover_effect","conv"=>"KV","tags"=>false),			//【extCatList4】 hover時効果
                    array("column"=>"catlist_auto_centering","conv"=>"","tags"=>false),			//【extCatList4】 自動中央揃え する・しない
                    // 【extCatList4】-->
                    array("column"=>"bg_color","conv"=>"","tags"=>false),			//背景色
                    array("column"=>"bdr_type","conv"=>"","tags"=>false),			//囲み線
                    array("column"=>"btm_padding","conv"=>"","tags"=>false),			//下部余白
                    array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
                    array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
                    array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),		//下方スペース
                    array("column"=>"use_pc_flg","conv"=>"n","tags"=>false),		//PC表示 v1.6
                    array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)			//下部余白
                    );
    var $_img_name = array(
         'catlist_nophoto_img'
        ,'catlist_newicon_img'
        ,'catlist_pager_img'
        ,'catlist_pager_img_hover'
    );

    //ユニットデータ
    var $_data = array();
    //ページデータ
    var $_page_data = array();
    //イージング種類
    var $_easing = array(
         "swing"=>"swing"
        ,"easeInQuad"=>"easeInQuad"
        ,"easeOutQuad"=>"easeOutQuad"
        ,"easeInOutQuad"=>"easeInOutQuad"
        ,"easeInCubic"=>"easeInCubic"
        ,"easeOutCubic"=>"easeOutCubic"
        ,"easeInOutCubic"=>"easeInOutCubic"
        ,"easeInQuart"=>"easeInQuart"
        ,"easeOutQuart"=>"easeOutQuart"
        ,"easeInOutQuart"=>"easeInOutQuart"
        ,"easeOutQuint"=>"easeOutQuint"
        ,"easeInOutQuint"=>"easeInOutQuint"
        ,"easeInSine"=>"easeInSine"
        ,"easeOutSine"=>"easeOutSine"
        ,"easeInOutSine"=>"easeInOutSine"
        ,"easeInExpo"=>"easeInExpo"
        ,"easeOutExpo"=>"easeOutExpo"
        ,"easeInOutExpo"=>"easeInOutExpo"
        ,"easeInCirc"=>"easeInCirc"
        ,"easeOutCirc"=>"easeOutCirc"
        ,"easeInOutCirc"=>"easeInOutCirc"
        ,"easeInElastic"=>"easeInElastic"
        ,"easeOutElastic"=>"easeOutElastic"
        ,"easeInOutElastic"=>"easeInOutElastic"
        ,"easeInBack"=>"easeInBack"
        ,"easeOutBack"=>"easeOutBack"
        ,"easeInOutBack"=>"easeInOutBack"
        ,"easeInBounce"=>"easeInBounce"
        ,"easeOutBounce"=>"easeOutBounce"
        ,"easeInOutBounce"=>"easeInOutBounce"
    );
    //エフェクト種類
    var $_effectType = "type_2";
    var $_effect = array(
                 "type_1" => array( "push"=>"push", "reverse"=>"reverse", "dissolve"=>"dissolve" )
                ,"type_2" => array( "fade-in"=>"fade-in", "move-in-top"=>"move-in-top", "move-in-right"=>"move-in-right", "move-in-bottom"=>"move-in-bottom", "move-in-left"=>"move-in-left", "scale"=>"scale" )
                ,"type_3" => array( "fade-out"=>"fade-out", "move-out-top"=>"move-out-top", "move-out-right"=>"move-out-right", "move-out-bottom"=>"move-out-bottom", "move-out-left"=>"move-out-left" )
            );


    function extCatList4()
    {
        $this->__construct();
    }

    function __construct()
    {
        unitCommon::__construct();
    }

    //出力データセット処理（必須）
    function setDisplayData() {
        $this->_data = $this->getDetail();
        //データがない場合はNULLを返す
        if (count($this->_data) == 0) {
            return null;
        }

        if(defined("SP_FLG") && SP_FLG == SP_FLG_CODE){
            if(is_numeric($this->_data['bg_color_sp'])) $this->_data['bg_color'] = $this->_data['bg_color_sp'];
            if(is_numeric($this->_data['bdr_type_sp'])) $this->_data['bdr_type'] = $this->_data['bdr_type_sp'];
            if(is_numeric($this->_data['btm_padding_sp'])) $this->_data['btm_padding'] = $this->_data['btm_padding_sp'];
        }
        /* v1.3 2009.07.14 完全動的にもどす*/
        $rtn = $this->setList($this->_data);

        //リストデータ
        $this->_data['list'] = $rtn["pagedata"];

        //ページング
        $this->_data['Pages'] = $rtn["Pages"];
        //選択されたカテゴリ名
        $this->_data['category'] = $rtn['category'];

        if($this->_data['catlist_default_bgcolor']==null){
            $this->_data['catlist_default_bgcolor'] = "transparent";
        }
        if($this->_data['catlist_hovered_bgcolor']==null){
            $this->_data['catlist_hovered_bgcolor'] = "transparent";
        }

        //RSSを表示するためのリンク作成
        $d = $this->getRequest('d');
        $c = "";
        $cat = explode(":", $this->_data['catlist_cat_code']);
        foreach ($cat as $val) {
            $c .= '&c[]='.$val;
        }
        $l = "";
        $lebel = explode(":", $this->_data['catlist_label_code']);
        foreach ($lebel as $val) {
            $l .= '&l[]='.$val;
        }
        $_tmp = ($this->_prev) ? '&prev=1' : '';

        //日付書式
        $this->_data['date_format'] = $this->date_format[ $this->_data['catlist_date_format'] ]['format'];

        //表示開始件数
        $catlist_s_count = (isset($this->_data['catlist_s_count'])) ? $this->_data['catlist_s_count'] : 0;
        $offset = $catlist_limit+($catlist_s_count-1);
        $this->_data['rss'] = "/rss.php?".$c.$l.'&d='.$d.'&s='.$this->_data['catlist_sidx_code'].'&o='.$this->_data['catlist_order'].'&offset='.$offset.$_tmp;

        // v1.6 no photo 画像
        $nophoto = "/admin/common-img/unit_list_dummy.jpg";
        if ( $this->_data['catlist_nophoto_img'] != "" ) {
            $nophoto = UNITS_IMG_PATH.$this->_data['catlist_nophoto_img'];
        }
        $this->_view->assign("nophoto", $nophoto);

        // v1.6 new アイコン画像
        if ( $this->_data['catlist_newicon_img'] != "" ) {
            $this->_view->assign("newicon", BINGOTOPURL.UNITS_IMG_PATH.$this->_data['catlist_newicon_img'] );
        }

        // v1.6 リンクテキスト
        if ( $this->_data['catlist_link_text'] == "" ) {
             $this->_data['catlist_link_text'] = "詳細はこちら";
        }

        // PC用レイアウトの選択
        //【extCatList4】-->
        //$num =  ( isset($this->_data['catlist_layout_pc']) && $this->_data['catlist_layout_pc'] != "" ) ?  $this->_data['catlist_layout_pc'] : "1";
        $num = 1;
        $layout = dirname(__FILE__)."/tpl_pc/layout" . str_pad($num, 3, "0", STR_PAD_LEFT) . ".tpl";
        $this->_view->assign("layout_pc", $layout);

        // SP用レイアウトの選択
        //【extCatList4】-->
        //$num =  ( isset($this->_data['catlist_layout_sp']) && $this->_data['catlist_layout_sp'] != "" ) ?  $this->_data['catlist_layout_sp'] : "1";
        $num = 1;
        $layout = dirname(__FILE__)."/tpl_sp/layout" . str_pad($num, 3, "0", STR_PAD_LEFT) . ".tpl";
        $this->_view->assign("layout_sp", $layout);

        // v1.6 ラベル情報
        $this->_view->assign("labelData", $this->getLabelData());
        //$this->_view->assign("sptpl", dirname(__FILE__)."/bCatListS-sp.tpl");
        if (count($this->_data) > 0) {
            return $this->_data;
        } else {
            return null;
        }
    }

    /*
     * DBより保存データ取得
     * 改変可能
     */
    function getDetail() {
        $rtn =  null;
        $sql = "select * from ".$this->getTbl()." where pageu_code = ?";
        if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
            $result = $this->db->prepare($sql,$this->_pageu_code);
            if($result!=null) {
                $rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);

                if ( $rtn ) {
                    $rtn['catlist_image_height'] = is_numeric($rtn['catlist_image_height']) ? $rtn['catlist_image_height']."%" : $rtn['catlist_image_height'];
                    $rtn['catlist_object_height'] = is_numeric($rtn['catlist_object_height']) ? $rtn['catlist_object_height']."px" : $rtn['catlist_object_height'];
                    $rtn['catlist_outside_weight'] = is_numeric($rtn['catlist_outside_weight']) ? $rtn['catlist_outside_weight']."px" : $rtn['catlist_outside_weight'];
                    $rtn['catlist_margin'] = is_numeric($rtn['catlist_margin']) ? $rtn['catlist_margin']."px" : $rtn['catlist_margin'];
                }
            }
        }
        return $rtn;
    }


    function setDefault()
    {
        $data = $this->getDetail();
        if (count($data) == 0) {
            $this->_form->setDefaults(array('catlist_limit'=>20,
                                            'catlist_date_flg'=>1,
                                            'catlist_comment_flg'=>1,
                                            'catlist_rss'=>1,
                                            'catlist_new_flg'=>1,
                                            'catlist_layout_pc' => 1,
                                            'catlist_layout_sp' => 1,
                                            'catlist_order'=>2,
                                            'catlist_comming_text' => 'COMMING SOON',
                                            'catlist_comming_flg' => 0,
                                            'catlist_nodata_text' => _gettext('B_T00801'),
                                            'catlist_link_text' => '詳細はこちら',
                                            'catlist_speed' => 600,
                                            'catlist_pflg' => 1,
                                            'catlist_pager_flg' => 0,
                                            'catlist_pager_text' => _gettext('B_P01056'),
                                            // 【extCatList4】<!--
                                            'catlist_image_height' => '50%',
                                            'catlist_object_height' => '400px',
                                            'catlist_margin' => '1px',
                                            'catlist_column' => 3,
                                            'catlist_outside_flg' => 1,
                                            'catlist_outside_weight' => '1px',
                                            'catlist_outside_color' => '#000000',
                                            'catlist_default_bgcolor' => '#FFFFFF',
                                            'catlist_hovered_bgcolor' => '#000000',
                                            'catlist_color' => '#000000',
                                            'catlist_color_hover' => '#FFFFFF',
                                            'catlist_auto_centering' => 0
                                            // 【extCatList4】-->
                                            ));
        }
        if ($this->getRequest('ocg') == '') {
            //カテゴリの初期値設定
            if (isset($data['catlist_cat_code'])) {
                $tmp = explode(":", $data['catlist_cat_code']);
                $data['catlist_cat_code']=array();
                foreach($tmp as $val) {
                    if($data['catlist_sidx_code']==$val){
                        $data['catlist_cat_code'][0] = $val;
                    }else{
                        $data['catlist_cat_code'][$val] = $val;
                    }
                }
            }

            //ラベルの初期値設定
            if (isset($data['catlist_label_code'])) {
                $tmp = explode(":", $data['catlist_label_code']);
                $data['catlist_label_code']=array();
                foreach($tmp as $val) {
                    $data['catlist_label_code'][$val] = $val;
                }
            }

            if (isset($data['catlist_sidx_code'])&&!empty($data['catlist_sidx_code'])) {
                $this->setCategoryObj($data['catlist_sidx_code'],$data['catlist_cat_code']);
            }
            if (isset($data['catlist_sidx_code'])&&is_numeric($data['catlist_sidx_code'])) {
                $this->setLabelObj($data['catlist_sidx_code']);
            }

        }

        foreach ( $this->_img_name as $column ) {
            if ($data[$column]) {
                $this->_view->assign($column, BINGOTOPURL.UNITS_IMG_PATH.$data[$column]);
            }
        }


        $this->_form->setDefaults($data);
    }

    //フォームエレメントの作成
    function setElements()
    {
        $this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
        //onChangeチェック用
        $this->_form->addElement('hidden','ocg', '1',array("id"=>"ocg"));
        //カテゴリ選択
        $data = array(''=>_gettext('B_P00567'),'0'=>_gettext('B_P00889')) + $this->getSectionData();
        $this->_form->addElement('select','catlist_sidx_code', null, $data, array('onChange'=>'reload();'));
        if ($this->getRequest('catlist_sidx_code') != '' && $this->getRequest('catlist_sidx_code')!=0) {
            $this->setCategoryObj($this->getRequest('catlist_sidx_code'));
        }

        //ラベル選択
        $catlist_sidx_code=isset($_POST["catlist_sidx_code"])?$_POST["catlist_sidx_code"]:null;
        if($catlist_sidx_code!==""&&$catlist_sidx_code!==null){
            $this->setLabelObj($catlist_sidx_code);
        }

        //表示開始
        $data = array('1'=>'1','2'=>'2','3'=>'3','4'=>'4','5'=>'5','6'=>'6','7'=>'7','8'=>'8','9'=>'9','10'=>'10');
        $this->_form->addElement('select','catlist_s_count', null, $data, array('id'=>'catlist_s_count'));
        //表示件数
        $data = array('1'=>'1','2'=>'2','3'=>'3','4'=>'4','5'=>'5','6'=>'6','7'=>'7','8'=>'8','9'=>'9','10'=>'10','20'=>'20','30'=>'30','40'=>'40','50'=>'50');
        $this->_form->addElement('select','catlist_limit', null, $data, array('id'=>'catlist_limit'));
        //ページングの有無
        $this->_form->addElement('advcheckbox','catlist_pflg', null, _gettext('B_P01047'), array('id'=>'catlist_pflg'),array(0,1));
        //公開日表示
        $this->_form->addElement('advcheckbox','catlist_date_flg', null, _gettext('B_P00533'), array('id'=>'catlist_date_flg'),array(0,1));
        //RSS
        $this->_form->addElement('advcheckbox','catlist_rss', null, _gettext('B_P00533'), array('id'=>'catlist_rss'),array(0,1));
        //NEWアイコン
        $this->_form->addElement('advcheckbox','catlist_new_flg', null, _gettext('B_P00533'), array('id'=>'catlist_new_flg'),array(0,1));
        //NEWアイコン表示期間
        $this->_form->addElement('text','catlist_new_days', null, array('size'=>'5', 'id'=>'catlist_new_days','value'=>7,'style'=>'ime-mode:disabled'));
        //一覧コメント
        $this->_form->addElement('advcheckbox','catlist_comment_flg', null, _gettext('B_P00533'), array('id'=>'catlist_comment_flg'),array(0,1));
        //COMMING SOON
        $this->_form->addElement('text', 'catlist_comming_text', null, array('size'=>'25', 'id'=>'catlist_comming_text', 'style'=>'' ));
        //COMMING SOONフラグ
        $this->_form->addElement('advcheckbox','catlist_comming_flg', null, _gettext('B_P00533'), array('id'=>'catlist_comming_flg'),array(0,1));
        //0件時の任意テキスト
        $this->_form->addElement('textarea','catlist_nodata_text', null, array('id'=>'catlist_nodata_text','rows'=>4));
        //リンクテキスト
        $this->_form->addElement('text', 'catlist_link_text', null, array('size'=>'25', 'id'=>'catlist_link_text', 'style'=>'' ));
        //No photo画像
        $this->_form->addElement('hidden','catlist_nophoto_img', null,array("id"=>"catlist_nophoto_img"));
        //new アイコン画像
        $this->_form->addElement('hidden','catlist_newicon_img', null,array("id"=>"catlist_newicon_img"));
        //ページング画像
        $this->_form->addElement('hidden','catlist_pager_img', null,array("id"=>"catlist_pager_img"));
        //ページング画像hover
        $this->_form->addElement('hidden','catlist_pager_img_hover', null,array("id"=>"catlist_pager_img_hover"));
        //ページング画像
        $this->_form->addElement('hidden','catlist_pager_img', null,array("id"=>"catlist_pager_img"));
        //ページング画像hover
        $this->_form->addElement('hidden','catlist_pager_img_hover', null,array("id"=>"catlist_pager_img_hover"));
        //エフェクト
        $this->_form->addElement('select','catlist_effect', null, $this->_effect[$this->_effectType], array('id'=>'catlist_effect'));
        //スピード
        $this->_form->addElement('text', 'catlist_speed', null, array('size'=>'10', 'id'=>'catlist_speed', 'style'=>'' ));
        //イージング
        $this->_form->addElement('select','catlist_easing', null, $this->_easing, array('id'=>'catlist_easing'));
        //ページングタイプ
        $item=array();
        $item[]=& $this->_form->createElement('radio',null, null,'ボタン',0);
        $item[]=& $this->_form->createElement('radio',null, null,'スクロール',1);
        $this->_form->addGroup($item,'catlist_pager_flg');
        $this->_form->getElement('catlist_pager_flg');
        //ページング任意テキスト
        $this->_form->addElement('text', 'catlist_pager_text', null, array('size'=>'20', 'id'=>'catlist_pager_text', 'style'=>'' ));
        //文字数
        $this->_form->addElement('text', 'catlist_body_charcnt', null, array('size'=>'10', 'id'=>'catlist_body_charcnt', 'style'=>'ime-mode:disabled' ));
        //画像削除ボタン
        foreach ( $this->_img_name as $column ) {
            $this->_form->addElement('checkbox', $column.'_delflg', null,_gettext('B_P00400'),null);//画像削除チェックボックス
            $this->_form->updateElementAttr($column.'_delflg',array('value'=>'delete'));
        }

        //表示順
        $item=array();
        $item[]=& $this->_form->createElement('radio',null, null,_gettext('B_P00890'),1);
        $item[]=& $this->_form->createElement('radio',null, null,_gettext('B_P00891'),2);
        $this->_form->addGroup($item,'catlist_order');
        $this->_form->getElement('catlist_order');

        $this->_form->addElement('advcheckbox','catlist_sp_layout', null, _gettext('B_P00916'), array(), array(0,1));

        //日付の表示形式
        $item = array();
        foreach ($this->date_format as $k => $v ) {
            $item[$k] = $v['disp'];
        }
        $this->_form->addElement('select', 'catlist_date_format', null, $item);
/*
        //レイアウトPC
        $item = array();
        $i = 1;
        if ( $dir = opendir (dirname(__FILE__)."/tpl_pc" ) ) {
            while (( $file = readdir($dir)) != false ) {
                if ($file != "." && $file != ".." && preg_match("/\.tpl$/", $file) ) {
                    $num = preg_replace("/layout([0-9]+)\.tpl/", "$1", $file);
                    $num = intval($num);
                    $item[$i++]=& $this->_form->createElement('radio',null, null, _gettext('B_T00207').$num, $num);
                }
            }
            asort($item);
        }
        $this->_form->addGroup($item,'catlist_layout_pc');
    */
        //レイアウトSP
    /*
        $item = array();
        $i = 1;
        if ( $dir = opendir (dirname(__FILE__)."/tpl_sp" ) ) {
            while (( $file = readdir($dir)) != false ) {
                if ($file != "." && $file != ".." && preg_match("/\.tpl$/", $file) ) {
                    $num = preg_replace("/layout([0-9]+)\.tpl/", "$1", $file);
                    $num = intval($num);
                    $item[$i++]=& $this->_form->createElement('radio',null, null, _gettext('B_T00207').$num, $num);
                }
            }
            asort($item);
        }
        $this->_form->addGroup($item,'catlist_layout_sp');
    */

        //【extCatList4】<!--
        //[] 画像の高さ、オブジェクトの高さ
        $this->_form->addElement('text', 'catlist_image_height', null, array('size'=>'15', 'id'=>'catlist_image_height', 'style'=>'ime-mode:disabled' ));
        $this->_form->addElement('text', 'catlist_object_height', null, array('size'=>'15', 'id'=>'catlist_object_height', 'style'=>'ime-mode:disabled' ));
        //横列数
        $item = array("1"=>"1", "2"=>"2", "3"=>"3", "4"=>"4", "5"=>"5");
        $this->_form->addElement('select','catlist_column', null, $item, array('id'=>'catlist_column'));
        //間隔
        $this->_form->addElement('text', 'catlist_margin', null, array('size'=>'15', 'id'=>'catlist_margin', 'style'=>'ime-mode:disabled' ));
        // [外枠] 表示
        $item=array();
        $item[]=& $this->_form->createElement('radio',null, null,'表示しない',0);
        $item[]=& $this->_form->createElement('radio',null, null,'表示する',1);
        $this->_form->addGroup($item,'catlist_outside_flg');
        $this->_form->getElement('catlist_outside_flg');
        //[外枠] 色
        $this->_form->addElement('text', 'catlist_outside_color', null, array('size'=>'7', 'id'=>'catlist_outside_color', 'style'=>'ime-mode:disabled' ));
        //[外枠] 太さ
        $this->_form->addElement('text', 'catlist_outside_weight', null, array('size'=>'15', 'id'=>'catlist_outside_weight', 'style'=>'ime-mode:disabled' ));
        //デフォルト背景色
        $this->_form->addElement('text', 'catlist_default_bgcolor', null, array('size'=>'7', 'id'=>'catlist_default_bgcolor', 'style'=>'ime-mode:disabled' ));
        //hover時 背景色
        $this->_form->addElement('text', 'catlist_hovered_bgcolor', null, array('size'=>'7', 'id'=>'catlist_hovered_bgcolor', 'style'=>'ime-mode:disabled' ));
        //文字色
        $this->_form->addElement('text', 'catlist_color', null, array('size'=>'7', 'id'=>'catlist_color', 'style'=>'ime-mode:disabled' ));
        //文字色 hover時
        $this->_form->addElement('text', 'catlist_color_hover', null, array('size'=>'7', 'id'=>'catlist_color_hover', 'style'=>'ime-mode:disabled' ));
        //自動中央揃え
        $this->_form->addElement('advcheckbox','catlist_auto_centering', null, '中央に揃える', array('id'=>'catlist_auto_centering'),array(0,1));
        //【extCatList4】-->
    }

    //フォーム入力エラーチェックの設定
    function setRules()
    {
        $this->_form->applyFilter('__ALL__','trim');
        $this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
        $this->_form->setJsWarnings(_gettext('B_P00472'),'');
        $this->_form->addRule('pageu_code',_gettext('B_P00643'),'required',null,$this->erchk);
        //$this->_form->addRule('catlist_layout_pc',_gettext('B_T00207'),'required',null,$this->erchk);
        //$this->_form->addRule('catlist_layout_sp',_gettext('B_T00207'),'required',null,$this->erchk);
        $this->_form->addRule('catlist_nodata_text',_gettext('B_P00210'),'check_br',null,$this->erchk);

        $this->_form->addRule('catlist_sidx_code',_gettext('B_P00882'),'required',null,$this->erchk);
        $this->_form->addRule('catlist_s_count',_gettext('B_P00883'),'required',null,$this->erchk);
        $this->_form->addRule('catlist_limit',_gettext('B_P00884'),'required',null,$this->erchk);
        $this->_form->addRule('catlist_new_days',_gettext('B_P00893'),'numeric',null,$this->erchk);
        $this->_form->addRule('catlist_order',_gettext('B_P00885'),'required',null,$this->erchk);
        $catlist_cat_code = $this->getRequest('catlist_cat_code');
        $catlist_label_code = $this->getRequest('catlist_label_code');

        if ($this->getRequest('buttons') != ''){
            if(is_numeric($this->getRequest("catlist_sidx_code"))){
                if($this->getRequest("catlist_sidx_code")==0){
                    if(!is_array($catlist_label_code)){
                        //$this->_form->setElementError('catlist_sidx_code', _gettext('B_P00881'));
                    }
                }else{
                    if(!is_array($catlist_cat_code)){
                        $this->_form->setElementError('catlist_cat_code', _gettext('B_P00878'));
                    }
                }
            }
        }

        $catlist_new_flg = $this->getRequest('catlist_new_flg');
        if ($catlist_new_flg != '0' && $this->getRequest('buttons') != '') {
            $this->_form->addRule('catlist_new_days',_gettext('B_P00877'),'required',null,$this->erchk);
        }

        //【extCatList4】<!--
        $this->_form->registerRule("check_css_color", "regex", "/^#[0-9a-fA-F]{3}$|^#[0-9a-fA-F]{6}$/");
        $this->_form->registerRule("check_css_property", "regex", "/^\d+$|\d+(px|em|pt|%)$|^auto$/");
        $this->_form->registerRule("check_css_percent", "regex", "/^\d+$|\d+(%)$|^auto$/");
        $this->_form->addRule("catlist_outside_color", _gettext('B_P01027', '外枠の色'), "check_css_color", null, "server");
        $this->_form->addRule("catlist_default_bgcolor", _gettext('B_P01027', 'デフォルトの背景色'), "check_css_color", null, "server");
        $this->_form->addRule("catlist_hovered_bgcolor", _gettext('B_P01027', 'hover時の背景色'), "check_css_color", null, "server");
        $this->_form->addRule("catlist_color", _gettext('B_P01027', 'テキストの文字色'), "check_css_color", null, "server");
        $this->_form->addRule("catlist_color_hover", _gettext('B_P01027', 'hover時のテキストの文字色'), "check_css_color", null, "server");
        $this->_form->addRule("catlist_image_height", _gettext('画像の高さは%で指定してください。'), "check_css_percent", null, "server");
        $this->_form->addRule("catlist_object_height", _gettext('B_P00991', 'オブジェクトの高さ'), "check_css_property", null, "server");
        $this->_form->addRule("catlist_margin", _gettext('B_P00991', '間隔'), "check_css_property", null, "server");
        $this->_form->addRule("catlist_outside_weight", _gettext('B_P00991', '外枠の太さ'), "check_css_property", null, "server");
        //【extCatList4】-->

    }

    //データ下書き保存処理
    function doSave($post)
    {
        $record = null;
        foreach($this->columns as $val) {
            if($post[$val["column"]]!=null){
                $record[$val["column"]] = $post[$val["column"]];
            } else {
                $record[$val["column"]] = null;
            }
        }
        //カテゴリは:区切りで保存
        if (is_array($this->getRequest('catlist_cat_code'))) {
            $data = $this->getRequest('catlist_cat_code');
            $str = array();
            foreach ($data as $k=>$v) {
                if($k==0){
                    $str[] =$record["catlist_sidx_code"];
                }else{
                    $str[] = $k;
                }
            }
            $record['catlist_cat_code'] = join(':', $str);
        }
        //ラベルは:区切りで保存
        if (is_array($this->getRequest('catlist_label_code'))) {
            $data = $this->getRequest('catlist_label_code');
            $str = array();
            foreach ($data as $k=>$v) {
                if($k==0){
                    $str[] =$record["catlist_label_code"];
                }else{
                    $str[] = $k;
                }
            }
            $record['catlist_label_code'] = join(':', $str);
        }

        //v1.6
        foreach( $this->_img_name as $_column ) {

            if($this->getRequest($_column."_delflg") != null) {
                $record[$_column]=null;
            }

            if(is_numeric($record[$_column])) {
                // ここでhidden属性（上記の数値に設定されたもの）を現在設定されている画像パスの状態にもどす
                // 前提：エラー時（画像以外の入力でエラーになった場合でも）は新しく選択したファイルが画面上から消えること（既存ファイルが選択されている状態に戻る）
                if(is_array($old_data)&& count($old_data)>0){
                    $this->_form->updateElementAttr($_column,array('value' => $old_data[$_column]));
                }
                $imgmngrDB = new imgmngrDB();
                $imgdata = $imgmngrDB->getImageFromCode($record[$_column], UNITS_IMG_PATH, $record["pageu_code"], 1);
                if(isset($imgdata)){
                    $data_path = $imgdata["img_src"]; 	// コピー元（素材管理の画像パス）
                    $img_path  = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
                    $record[$_column] = array_pop(explode('/',$img_path)); //保存ファイル名取得
                    $cpflg = true;
                }else{
                    return _gettext('B_P00651');
                }
            }
            // saas
            $fsize = array();
            if($cpflg) $fsize[] = array('size' => filesize(BASE_PATH.$data_path));
            if (count($fsize)>0 && !commonFile::chkSaveFiles($fsize)) {
                return _gettext('B_P00281');
            }
            if($cpflg) {
                if(!@copy(BASE_PATH.$data_path, BASE_PATH.$img_path)){
                    return _gettext('B_P00650');
                } else {
                    @chmod(BASE_PATH.$img_path, 0666);
                }
            }
        }

        //既存データがあるか確認
        $old_data = $this->getDetail();
        $this->db->query('BEGIN');
        //保存処理開始
        if(is_array($old_data)&& count($old_data)>0) {
            //更新
            if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
                $this->db->query('ROLLBACK');
                return _gettext('B_P00209');
            }
        } else { //新規
            if(!$this->db->insert($this->getTbl(),$record)) {
                $this->db->query('ROLLBACK');
                return _gettext('B_P00209');
            }
        }
        $this->db->query('COMMIT');
        return null;
    }

    function getSectionData()
    {
        $_tmp = ($this->_prev) ? '_tmp' : '';
        //v1.2 連載型モジュールで生成したメニューからのみ選択可能とする。
        /*
        $sql = "select sidx_code,sidx_title,sidx_order from tbl_section_idx{$_tmp}
                    where sidx_active=1 and sidx_extmodule_code = {$this->_unit_data["unit_extmodule_code"]}
                    order by sidx_order";*/
        $sql = "select sidx_code,sidx_title,sidx_order from tbl_section_idx{$_tmp}
                    where sidx_active=1 AND sidx_parent_sidx_code=0 AND (sidx_extmodule_code IS NULL OR NOT(sidx_extmodule_code >=1000 AND sidx_extmodule_code < 2000)) order by sidx_order";
        $return = $this->db->query($sql);
        if (DB::IsError($return)) {
            die();
        }
        $data = array();
        while($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
            $data[$row['sidx_code']] = $row['sidx_title'];
        }
        return $data;
    }

    /**
    * セクションIDXコードからカテゴリをQFにセットする
    *
    * @author Nobuo Nishino
    * @param integer $catlist_sidx_code セクションIDXコード
    * @param array $default カテゴリコードの配列
    */
    function setCategoryObj($catlist_sidx_code=null, $default=array())
    {
        $_tmp = ($this->_prev) ? '_tmp' : '';
        $checks = array();
        //v1.2
        $sql = "select sidx_code, sidx_title, sidx_order from tbl_section_idx{$_tmp}
        where sidx_active = 1 and (sidx_parent_sidx_code = {$catlist_sidx_code})
        order by sidx_order ";
        $return = $this->db->query($sql);
        if (DB::IsError($return)) {
            die();
        }
        $checks[] =& $this->_form->createElement('checkbox', "0", null, _gettext('B_P00886'));
        while($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
            $checks[] =& $this->_form->createElement('checkbox', $row['sidx_code'], null, $row['sidx_title']);
        }
        $this->_form->addGroup($checks, 'catlist_cat_code', null, "<br />\n");
//		if ($catlist_sidx_code != null) {
//			$_tmp = ($this->_prev) ? '_tmp' : '';
//			$checks = array();
//			//v1.2
//			$sql = "select cat_code, cat_name, cat_order from tbl_category{$_tmp}
//			where cat_active = 1 and (cat_sidx_code = {$catlist_sidx_code} or cat_code = 1)
//			order by cat_order ";
//			$return = $this->db->query($sql);
//			if (DB::IsError($return)) {
//				die();
//			}
//			while($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
//				$checks[] =& $this->_form->createElement('checkbox', $row['cat_code'], null, $row['cat_name']);
//			}
//			$this->_form->addGroup($checks, 'catlist_cat_code', null, "<br />\n");
//		}
    }

    function setLabelObj($catlist_sidx_code=null){
        //SaaS
        $data=$this->getDetail();
        $catlist_sidx_code = is_null($catlist_sidx_code)? $data["catlist_sidx_code"]:$catlist_sidx_code;
        if($catlist_sidx_code==0)$catlist_sidx_code="";
        $checks = array();
        $_param=array();
        $_bind=array();
        $labels=null;
        $sql = "SELECT * FROM tbl_label WHERE label_active=1 and label_admin_type=0 ";// label_admin_type を追加 2010.06.03 sugi
        if(is_numeric($catlist_sidx_code)){
            //メニュー・ローカルのページ一覧取得
            $_sql="SELECT
                pidx_code,
                pidx_sidx_code,
                pidx_cat_code,
                pidx_extmodule_code,
                pidx_title,
                pidx_label
                FROM tbl_section_idx_tmp as s
                JOIN tbl_page_idx_tmp as p
                ON s.sidx_code=p.pidx_sidx_code
                AND p.pidx_ptype=1 AND p.pidx_active=1
                WHERE sidx_code=? OR sidx_parent_sidx_code=?";
            $result=$this->db->prepare($_sql,array($catlist_sidx_code,$catlist_sidx_code));
            if($result){
                $labels=array();
                while($row=$result->fetchRow(DB_FETCHMODE_ASSOC)){
                    if(!empty($row["pidx_label"])){
                        $labels=array_unique(array_merge($labels,explode("<>",$row["pidx_label"])));
                    }
                }
            }

            if(!empty($labels)&&is_array($labels)){
                foreach($labels as $k=>$v){
                    $_bind[]="?";
                    $_param[]=$v;
                }
                $sql .=" AND label_code IN(".implode(",",$_bind).")";
            }else{
                $sql .=" AND 1=0";
            }
        }
        $return = $this->db->prepare($sql,$_param);
        if (DB::IsError($return)) {
            die();
        }
        while($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
            $checks[] =& $this->_form->createElement('checkbox', $row['label_code'], null, $row['label_name']);
        }
        $this->_form->addGroup($checks, 'catlist_label_code', null, "<br />\n");
    }

    /**
    * 選択されているカテゴリからパラメータに合わせて一覧を表示する
    *
    * @author Nobuo Nishino
    * @param array $data データの配列
    */
    function setList($data)
    {
        //リクエストページ番号
//		if($this->_pageu_code == $this->getRequest('pageu_code')) { //v1.3
             $idx = $this->getRequest('idx');
//		}

        if( !is_numeric($idx) || $idx < 1) {
            $idx=1;
        }
        $this->_view->assign("thisPageNum", $idx);

        // 2014.08 v1.6
        $this->getNextPage($idx);

        $rtn = null;
        if (is_array($data)) {
            //カテゴリ
            $cat = array(0);
            if (isset($data['catlist_cat_code'])) {
                $cat = explode(":", $data['catlist_cat_code']);
            }
            $cat = join(',', $cat);

            //ラベル
            if (isset($data['catlist_label_code'])) {
                $_label = explode(":", $data['catlist_label_code']);
            }
            $label_flg=false;//ラベル設定されているかの判定用
            $label = array();
            if(!empty($_label[0])){
                //ラベルをフィルター。アクティブ以外は破棄
                $label_flg = true;
                $result = $this->db->query("SELECT label_code FROM tbl_label WHERE label_code IN(".implode(",", $_label).") AND label_active=1");
                if($result){
                    while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
                    $label[] = $row["label_code"];
                }
            }
        }

        //セクションコード
        $pidx_sidx_code = (isset($data['catlist_sidx_code'])) ? $data['catlist_sidx_code'] : 0;
        //表示順
        $catlist_order = (isset($data['catlist_order']) && $data['catlist_order'] == 2) ? 'DESC' : '';
        //表示開始件数
        $catlist_s_count = (isset($data['catlist_s_count'])) ? $data['catlist_s_count'] : 0;
        //表示件数
        $catlist_limit = (isset($data['catlist_limit'])) ? $data['catlist_limit'] : 10;
        //NEW表示日数
        $catlist_new_days = (isset($data['catlist_new_days'])) ? $data['catlist_new_days'] : 7;
        //タイムスタンプ値に変更
        $catlist_new_days = $catlist_new_days * 86400;

        $offset = ($idx-1)*$catlist_limit+($catlist_s_count-1);
        //該当するカテゴリからページ情報を取得
        if(defined('BINGO_VERSION') && version_compare('1.7.0', BINGO_VERSION, '<=')) {
            $nowdate = date('Y-m-d H:i:s');
        } else {
            $nowdate = date('Y-m-d');
        }

        //@FIXME 2011.04.28 公開時、プレビュー時を同じ表示とする ami
        //$_tmp = ($this->_prev) ? '_tmp' : '';
        $sql="
            SELECT
            p1.pidx_code,
            pidx_title,
            s1.sidx_code as cat_code,
            s2.sidx_code as sidx_code,
            s1.sidx_dir as cat_dir,
            s2.sidx_dir as sidx_dir,
            s1.sidx_title as cat_name,
            CASE
            WHEN s2.sidx_order IS NULL THEN s1.sidx_order
            ELSE s2.sidx_order END as menu_sidx_order,
            CASE
            WHEN s2.sidx_code IS NULL THEN s1.sidx_code
            ELSE s2.sidx_code END as menu_sidx_code,
            CASE
            WHEN s1.sidx_ssl=1 OR s2.sidx_ssl=1 THEN 1
            ELSE NULL END as sidx_ssl,
            pidx_date,
            pidx_comment,
            pidx_url,
            pidx_comment_pic,
            pidx_comment_pic2,
            skin_path,
            pidx_directurl,
            pidx_directurl_flg,
            pidx_label

            FROM tbl_page_idx as p1

            JOIN tbl_section_idx as s1
            ON s1.sidx_code=p1.pidx_sidx_code

            LEFT JOIN tbl_section_idx as s2
            ON s1.sidx_parent_sidx_code=s2.sidx_code

            JOIN tbl_template
            ON s1.sidx_tpl_code = tpl_code

            JOIN tbl_skin
            ON tpl_skin_code = skin_code

            WHERE pidx_ptype=1
            AND pidx_active=1
            AND pidx_view IN(0,2)
            AND s1.sidx_active=1
            AND s1.sidx_view=2 AND (s2.sidx_view=2 OR s2.sidx_view IS NULL)
            AND (s1.sidx_extmodule_code IS NULL OR NOT(s1.sidx_extmodule_code >=1000 AND s1.sidx_extmodule_code < 2000))";
        /*
        //2011.03.17 sugi
        //$sql .="AND (s2.sidx_view=2 OR s2.sidx_view IS NULL) ";
        if(!$this->_prev){
            $sql.="AND s1.sidx_view=2 AND (s2.sidx_view=2 OR s2.sidx_view IS NULL) ";
        }
        $sql .="AND (s1.sidx_extmodule_code IS NULL OR NOT(s1.sidx_extmodule_code >=1000 AND s1.sidx_extmodule_code < 2000))";
        */
        if($cat!=0)$sql.=" AND s1.sidx_code IN({$cat})";
            if($label_flg){
                if(!empty($label)){
                    $sql.=" AND (";
                    foreach($label as $k=>$code){
                        if($k>0) $sql.=" OR ";
                        $sql.="
                         pidx_label={$code}
                         OR pidx_label LIKE '{$code}<>%'
                         OR pidx_label LIKE '%<>{$code}<>%'
                         OR pidx_label LIKE '%<>{$code}'";
                    }
                    $sql.=")";
                }else{
                    $sql .=" AND 1=0";
                }
            }
            if ( $data['catlist_comming_flg'] == 0 ) {
                $sql.=" AND pidx_date <= '{$nowdate}' ";
            }
            $sql.=" AND (pidx_edate Is Null OR pidx_edate >= '{$nowdate}') ";
            //$sql .= "ORDER BY p1.pidx_date {$catlist_order}, menu_sidx_order ASC, menu_sidx_code ASC, s2.sidx_order ASC, s2.sidx_code ASC, s1.sidx_order ASC, s1.sidx_code ASC, pidx_order ASC, pidx_code DESC ";
            //2011.03.17 sugi
            $sql .= "ORDER BY p1.pidx_order desc, p1.pidx_date {$catlist_order}, p1.pidx_u_date {$catlist_order}, menu_sidx_order ASC, menu_sidx_code ASC, s2.sidx_order ASC, s2.sidx_code ASC, s1.sidx_order ASC, s1.sidx_code ASC, pidx_code DESC ";
            //スマホレイアウト表示時＋ページング時は全件取得
            if($data["use_sp_flg"]==1 && $data["catlist_sp_layout"] && $data["catlist_pflg"] == 1 && defined('SP_FLG') && SP_FLG==SP_FLG_CODE){
                $offset = $catlist_s_count-1;
                $sql .= "LIMIT 9999 Offset {$offset}";
            }else{
                $sql .= "LIMIT {$catlist_limit} Offset {$offset}";

                // 最終ページのチェック
                $total = $this->getPageCount($data, $sql); // ページャー設定より移動
                $pageCnt = $catlist_limit * $idx;
                $lastPage =  ( $pageCnt >= $total ) ? 1:0;
                $this->_view->assign("lastPage" , $lastPage);
                $this->_view->assign("current", $idx);
            }

            //※2
            $return = $this->db->query($sql);
            if (DB::IsError($return)) {
                die();
            }
            //現在のタイムスタンプ
            $now = strtotime(date('Y-m-d H:i:s'));
            //カテゴリ名
            $cat_name = array();
            //開始ページ判定用変数
            $i = 1;
            while($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
                if(is_null($row["sidx_code"])){
                    $row["sidx_code"]=$row["cat_code"];
                    $row["cat_code"]=null;
                    $row["sidx_dir"]=$row["cat_dir"];
                    $row["cat_dir"]=null;
                }
                //画像ファイルパス
                $row['PIDX_IMG_PATH'] = PIDX_IMG_PATH;
                //カミングスーンフラグ
                $row['comming'] = (strtotime($row['pidx_date']) > $now ) ? 1: 0;
                //NEW_FLG
                $row['newflg'] = (strtotime($row['pidx_date']) + $catlist_new_days >= $now) ? 1 : 0;
                $row['newflg'] = ($row['comming'] == 1 ) ? 0 : $row['newflg'];

                //SKIN_PATH
                $row['skin_path'] = $row['skin_path'];
                //ページのリンク設定
                $row['url'] = pageView::getSiteURL($row["sidx_dir"],$row['cat_dir'],$row['pidx_url'],$row["sidx_ssl"],$prev=false, false, true);
                $this->_page_data[] = $row;
                if (!in_array($row['cat_name'], $cat_name)) {
                    $cat_name[] = $row['cat_name'];
                }
                $i++;
            }
            //ページャー設定
            if ($data['catlist_pflg'] == 1) {
                ////条件が複雑なので今後のことも考えて件数の取得方法を変更 2011.03.17 sugi
                ////$total = $this->getPageCount($data); //公開記事総数
                //$total = $this->getPageCount($data, $sql); //公開記事総数

                /* v1.3 動的にもどす*/
                $params = array('mode' => 'sliding',
                        "totalItems" => $total,
                        'perPage' => $catlist_limit,
                        'delta' => 2,
                        'prevImg' => '&lt;&lt;&nbsp;&nbsp;',
                        'nextImg' => '&nbsp;&gt;&gt; ',
                        'urlVar' => "idx",
                        'currentPage' => $idx,
                        "curPageSpanPre" => "<b>[",
                        "curPageSpanPost" => "]</b>",
                        'separator' => '&nbsp;',
                        'clearIfVoid'=>true,
                        'spacesBeforeSeparator' => 1,
                        'spacesAfterSeparator' => 1,
                        'itemData' => null,
                        'httpMethod' => "GET",
                        "firstPagePre" => "[",
                        "firstPageText" => _gettext('B_P00519'),
                        "firstPagePost" => "]",
                        "lastPagePre" => "[",
                        "lastPageText" => _gettext('B_P00502'),
                        "lastPagePost" => "]",
                        "append"   => FALSE,
                        "fileName" => "index.php?d=".$this->getRequest("d")."&c=".$this->getRequest("c")."&p=".$this->getRequest("p")."&pageu_code=".$this->_pageu_code."&idx=%d"
                );
                if($this->_prev == 1) { //v1.3
                    $params["fileName"] = $params["fileName"]."&prev=1";
                }
                else if ( $this->getRequest("spprev") ){
                    $params["fileName"] = $params["fileName"]."&spprev=1";
                }
                //アンカー追加
                //$params["fileName"] = $params["fileName"]."#unit-".$this->_pageu_code;
                $pager = & Pager::factory($params);
                //ページナビ
                $links= $pager->getLinks();
                if(isset($links["all"]) && $links["all"]!='') {
                    $rtn["Pages"] =$links["all"];
                }
            // ※1コメントアウト部分：最終行に移動
            }
            $rtn["pagedata"] = $this->_page_data;
            $rtn['category'] = $cat_name;
            //print_r($rtn);
            return $rtn;
        }
    }
    //ページ件数取得
    function getPageCount($data, $sql) {
        //※3 コメントアウト部分移動

        //2011.03.17 sugi
        if (is_array($data)) {
            //表示開始件数
            $catlist_s_count = (isset($data['catlist_s_count'])) ? $data['catlist_s_count'] : 0;
            $offset = $catlist_s_count -1 ;
            $patterns = array();
            $patterns[0] = '/SELECT.+FROM/is';
            $patterns[1] = '/ORDER BY.+$/is';
            $replacements = array();
            $replacements[0] = 'SELECT count(pidx_code) FROM';
            $replacements[1] = '';
            $sql = preg_replace($patterns, $replacements, $sql);
            return $this->db->getOne($sql) - $offset;
        }
        return 0;
    }

    //v1.6用ラベルデータ（マスタ用）
    function getLabelData() {
        $labelDB = new labelDB;
        $data = $labelDB->getlistAll();
        $list = array();
        foreach ($data as $k => $v) {
            $list[$v['label_code']] = $v;
        }
        return $list;
    }

    function getNextPage($page=1) {

        $prev = ($this->getRequest("prev") == 1) ? 1 : 0;
        if ( $prev == 1 ) {
            $nextPage = $_SERVER['SCRIPT_NAME'];
            $get = $_GET;
        } else {
            $nextPage = CURRENTURL;
            $get = array();
            $tmp = explode("?", $nextPage);
            if ( isset( $tmp[1] ) ) {
                $getStr = explode("&", $tmp[1]);
                foreach ( $getStr as $v ) {
                    $p = explode("=", $v);
                    if ( isset($p[1]) == 2 ) {
                        $get[$p[0]] = $p[1];
                    } else {
                        $get[$v] = "";
                    }
                }
            }
        }
        //if ( count($get) ) {
            if ( preg_match("/\?/", $nextPage) ) {
                $nextPage .= "&";
            } else {
                $nextPage .= "?";
            }
            foreach ( $get as $key => $val ) {
                if ( $key == 'idx' ) {
                    $page = ( is_numeric($val) && $val > 0 ) ? $val : $page;
                } else if ( $prev == 1 ) {
                    $nextPage .= $key ."=" .$val ."&";
                }
            }
            $nextPage = preg_replace("/&$/", "", $nextPage);
            $nextPage .= "&idx=". ($page + 1);
            $nextPage = preg_replace("/\?&/", "?", $nextPage);
        //}

        $this->_view->assign("nextPageNum", $page);
        $this->_view->assign("nextPage", $nextPage);

    }
}


// ※1
                /*
                if(!$this->_prev) {
                    //ページあたりの件数
                    $pn = $data["catlist_limit"];
                    $rtn["Pages"] = null;

                    //前へ
                    if($idx>1) {
                        $rtn["Pages"] .= '&nbsp;<a title="prev page" href="#noscript" onclick="getCatList'.$data["pageu_code"].'('.($idx-1).')"> &lt;&lt; </a>&nbsp;';
                    }
                    //ページ番号リンク
                    if($idx<3) {
                        $start = 1;
                        $end = $start+4;
                    } else {
                        $start = $idx-2;
                        $end = $idx+2;
                    }
                    $pagelinks = array();
                    for($i = $start; $i<=$end; $i++) {
                        if($i==$idx) {
                            $pagelinks[] = '&nbsp;<b>['.($i).']</b>&nbsp;';
                        }else 	if($total>$pn*($i-1)) {
                            $pagelinks[] = '&nbsp;<a href="#noscript" onclick="getCatList'.$data["pageu_code"].'('.($i).')">'.($i).'</a>&nbsp;';
                        }
                    }
                    if(count($pagelinks)>1) {
                        $rtn["Pages"] .= implode("\n", $pagelinks);
                    }
                    //次へ
                    if($total>$pn*($idx)) {
                        $rtn["Pages"] .= '&nbsp;<a title="next page" href="#noscript" onclick="getCatList'.$data["pageu_code"].'('.($idx+1).')"> &gt;&gt; </a>&nbsp;';
                    }
                } else {
                    $params = array('mode' => 'sliding',
                        "totalItems" => $total,
                        'perPage' => $catlist_limit,
                        'delta' => 2,
                        'prevImg' => '&lt;&lt;&nbsp;&nbsp;',
                        'nextImg' => '&nbsp;&gt;&gt; ',
                        'urlVar' => "idx",
                        'currentPage' => $idx,
                        "curPageSpanPre" => "<b>[",
                        "curPageSpanPost" => "]</b>",
                        'separator' => '&nbsp;',
                        'clearIfVoid'=>true,
                        'spacesBeforeSeparator' => 1,
                        'spacesAfterSeparator' => 1,
                        'itemData' => null,
                        'httpMethod' => "GET",
                        "firstPagePre" => "[",
                        "firstPageText" => _gettext('B_P00519'),
                        "firstPagePost" => "]",
                        "lastPagePre" => "[",
                        "lastPageText" => _gettext('B_P00502'),
                        "lastPagePost" => "]"
                        );
                    $pager = & Pager::factory($params);
                    //ページナビ
                    $links= $pager->getLinks();
                    if(isset($links["all"]) && $links["all"]!='') {
                        $rtn["Pages"] =$links["all"];
                    }
                }*/

// ※2
//			$sql = "SELECT
//					cat_name,sidx_dir,cat_dir,pidx_code,pidx_title,pidx_date,pidx_comment,pidx_url,sidx_ssl,pidx_comment_pic,skin_path,pidx_directurl
//					FROM tbl_page_idx{$_tmp}
//					INNER JOIN tbl_category{$_tmp} ON pidx_cat_code = cat_code
//					INNER JOIN tbl_section_idx{$_tmp} ON pidx_sidx_code = sidx_code
//					INNER JOIN tbl_template on sidx_tpl_code = tpl_code
//					INNER JOIN tbl_skin on tpl_skin_code = skin_code
//					WHERE pidx_active = 1 AND
//					sidx_active = 1 AND
//					cat_active = 1 AND
//					pidx_ptype = 0 AND
//					pidx_sidx_code = {$pidx_sidx_code} AND
//					pidx_date <= '{$nowdate}' AND
//					(pidx_edate Is Null OR pidx_edate >= '{$nowdate}') AND
//					pidx_cat_code IN ({$cat})
//					ORDER BY pidx_date {$catlist_order}
//					LIMIT {$catlist_limit}
//					Offset {$offset}
//					";

// ※3
/*
        if (is_array($data)) {
            //カテゴリ
            $cat = array(0);
            if (isset($data['catlist_cat_code'])) {
                $cat = explode(":", $data['catlist_cat_code']);
            }
            $cat = join(',', $cat);
            //ラベル
            if (isset($data['catlist_label_code'])) {
                $label = explode(":", $data['catlist_label_code']);
            }
            //セクションコード
            $pidx_sidx_code = (isset($data['catlist_sidx_code'])) ? $data['catlist_sidx_code'] : 0;
            //表示順
            $catlist_order = (isset($data['catlist_order']) && $data['catlist_order'] == 2) ? 'DESC' : '';
            //表示開始件数
            $catlist_s_count = (isset($data['catlist_s_count'])) ? $data['catlist_s_count'] : 0;
            //表示件数
            $catlist_limit = (isset($data['catlist_limit'])) ? $data['catlist_limit'] : 10;
            //NEW表示日数
            $catlist_new_days = (isset($data['catlist_new_days'])) ? $data['catlist_new_days'] : 7;
            //タイムスタンプ値に変更
            $catlist_new_days = $catlist_new_days * 86400;
            $nowdate = date('Y-m-d');
            $_tmp = ($this->_prev) ? '_tmp' : '';
            $offset = $catlist_s_count -1 ;
            $sql="SELECT
            count(p1.pidx_code)
            FROM tbl_page_idx{$_tmp} as p1
            JOIN tbl_section_idx{$_tmp} as s1
            ON s1.sidx_code=pidx_sidx_code
            LEFT JOIN tbl_section_idx{$_tmp} as s2
            ON s1.sidx_parent_sidx_code=s2.sidx_code
            JOIN tbl_template
            ON s1.sidx_tpl_code = tpl_code
            JOIN tbl_skin
            ON tpl_skin_code = skin_code
            WHERE pidx_ptype=1
            AND pidx_active=1
            AND s1.sidx_active=1 ";
            if(!$this->_prev){
                $sql.="AND (s2.sidx_view=2 OR s2.sidx_view IS NULL) ";
            }
            $sql.="AND (s1.sidx_extmodule_code IS NULL OR NOT(s1.sidx_extmodule_code >=1000 AND s1.sidx_extmodule_code < 2000))";
            if($cat!=0)$sql.=" AND s1.sidx_code IN({$cat})";
            if(!empty($label)){
                $sql.=" AND (";
                foreach($label as $k=>$code){
                    if($k>0)$sql.=" OR ";
                    $sql.="
                         pidx_label={$code}
                     OR pidx_label LIKE '{$code}<>%'
                     OR pidx_label LIKE '%<>{$code}'
                     OR pidx_label LIKE '%<>{$code}'";
                }
                $sql.=")";
            }
            $sql.="	AND pidx_date <= '{$nowdate}' AND
            (pidx_edate Is Null OR pidx_edate >= '{$nowdate}')";

//			$sql = "SELECT count(*)
//					FROM tbl_page_idx{$_tmp}
//					INNER JOIN tbl_category{$_tmp} ON pidx_cat_code = cat_code
//					INNER JOIN tbl_section_idx{$_tmp} ON pidx_sidx_code = sidx_code
//					INNER JOIN tbl_template on sidx_tpl_code = tpl_code
//					INNER JOIN tbl_skin on tpl_skin_code = skin_code
//					WHERE pidx_active = 1 AND
//					sidx_active = 1 AND
//					cat_active = 1 AND
//					pidx_ptype = 0 AND
//					pidx_sidx_code = {$pidx_sidx_code} AND
//					pidx_date <= '{$nowdate}' AND
//					(pidx_edate Is Null OR pidx_edate >= '{$nowdate}') AND
//					pidx_cat_code IN ({$cat})
//					";
            return $this->db->getOne($sql) - $offset;
        }
*/

?>
